"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jsonata = require("jsonata");
const chai_1 = require("chai");
const regexMatcher_1 = require("../lib/regexMatcher");
const webhook_receiver_1 = require("../lib/webhook-receiver");
let r;
exports.webhookStepRunners = () => [
    regexMatcher_1.regexMatcher(/^the Webhook Receiver "([^"]+)" should be called$/)(async ([MessageGroupId], _, runner) => r.receiveWebhookRequest(MessageGroupId, runner).then(r => r.body)),
    regexMatcher_1.regexMatcher(/^"([^"]+)" of the webhook request body should equal "([^"]+)"$/)(async ([exp, expected]) => {
        const e = jsonata(exp);
        chai_1.expect(r.latestWebhookRequest).not.to.be.an('undefined');
        const b = r.latestWebhookRequest && r.latestWebhookRequest.body;
        chai_1.expect(b).not.to.be.an('undefined');
        const result = e.evaluate(b);
        chai_1.expect(result).to.deep.equal(expected);
        return b;
    }),
    regexMatcher_1.regexMatcher(/^the webhook request body should equal this JSON$/)(async (_, step) => {
        if (!step.interpolatedArgument) {
            throw new Error('Must provide argument!');
        }
        const j = JSON.parse(step.interpolatedArgument);
        const b = r.latestWebhookRequest && r.latestWebhookRequest.body;
        chai_1.expect(b).not.to.be.an('undefined');
        chai_1.expect(b).to.deep.equal(j);
        return b;
    }),
    regexMatcher_1.regexMatcher(/^I have a Webhook Receiver/)(async (_, __, runner) => {
        r = new webhook_receiver_1.WebhookReceiver(runner.world.webhookQueue);
        await r.clearQueue();
    }),
];
